import { ISwagger, ISwaggerInfo, ISwaggerDefinition } from "./i-swagger";
import { IApiPathArgs } from "./api-path.decorator";
import { IApiOperationPostArgs } from "./api-operation-post.decorator";
import { IApiOperationGetArgs } from "./api-operation-get.decorator";
export declare class SwaggerService {
    private static controllerMap;
    private static definitionsMap;
    private static data;
    static getData(): ISwagger;
    static setBasePath(basePath: string): void;
    static setOpenapi(openapi: string): void;
    static setInfo(info: ISwaggerInfo): void;
    static setSchemes(schemes: string[]): void;
    static setProduces(produces: string[]): void;
    static setConsumes(consumes: string[]): void;
    static setHost(host: string): void;
    static setDefinitions(definitions: {
        [key: string]: ISwaggerDefinition;
    }): void;
    static addPath(args: IApiPathArgs, target: any): void;
    static addOperationGet(args: IApiOperationGetArgs, target: any, propertyKey: string | symbol): void;
    static addOperationPost(args: IApiOperationPostArgs, target: any, propertyKey: string | symbol): void;
    static addOperationPut(args: IApiOperationPostArgs, target: any, propertyKey: string | symbol): void;
    static addOperationPatch(args: IApiOperationPostArgs, target: any, propertyKey: string | symbol): void;
    static addOperationDelete(args: IApiOperationPostArgs, target: any, propertyKey: string | symbol): void;
    private static addOperation(operation, args, target, propertyKey);
    private static buildOperation(args, target, propertyKey);
    private static buildParameters(type, parameters);
    static buildSwagger(): void;
    private static buildRef(definition);
}
